Open Babel: Plugins

Classes | Files | Defines | Typedefs | Functions | Variables

# Plugins

## Classes
struct | CharPtrLess
| Case insensitive string comparison for PluginMapType key. More...
class | OBPlugin
| Base class for all types of dynamic classes discovered at runtime. More...
## Files
file | plugin.h
## Defines
#define | MAKE_PLUGIN(BaseClass)
#define | OB_STATIC_PLUGIN(className, instanceName)
## Typedefs
typedef PluginMapType::const_iterator | PluginIterator
## Functions
virtual | ~OBPlugin ()
virtual const char * | Description ()
virtual const char * | TypeID ()
virtual bool | Display (std::string &txt, const char *param, const char *ID=NULL)
virtual OBPlugin * | MakeInstance (const std::vector< std::string > &)
virtual void | Init ()
static OBPlugin * | GetPlugin (const char *Type, const char *ID)
const char * | GetID () const
static bool | ListAsVector (const char *PluginID, const char *param, std::vector< std::string > &vlist)
static void | List (const char *PluginID, const char *param=NULL, std::ostream *os=&std::cout)
static std::string | ListAsString (const char *PluginID, const char *param=NULL)
static std::string | FirstLine (const char *txt)
static PluginIterator | Begin (const char *PluginID)
static PluginIterator | End (const char *PluginID)
virtual PluginMapType & | GetMap () const =0
static PluginMapType & | PluginMap ()
static PluginMapType & | GetTypeMap (const char *PluginID)
static OBPlugin * | BaseFindType (PluginMapType &Map, const char *ID)
| OB_STATIC_PLUGIN (ACRFormat, theACRFormat)
| OB_STATIC_PLUGIN (ADFOutputFormat, theADFOutputFormat)
| OB_STATIC_PLUGIN (ADFInputFormat, theADFInputFormat)
| OB_STATIC_PLUGIN (AlchemyFormat, theAlchemyFormat)
| OB_STATIC_PLUGIN (AmberPrepFormat, theAmberPrepFormat)
| OB_STATIC_PLUGIN (OBAPIInterface, theOBAPIInterface)
| OB_STATIC_PLUGIN (BallStickFormat, theBallStickFormat)
| OB_STATIC_PLUGIN (BGFFormat, theBGFFormat)
| OB_STATIC_PLUGIN (BoxFormat, theBoxFormat)
| OB_STATIC_PLUGIN (CacaoFormat, theCacaoFormat)
| OB_STATIC_PLUGIN (CacheFormat, theCacheFormat)
| OB_STATIC_PLUGIN (CARFormat, theCARFormat)
| OB_STATIC_PLUGIN (CCCFormat, theCCCFormat)
| OB_STATIC_PLUGIN (CHEM3D1Format, theCHEM3D1Format)
| OB_STATIC_PLUGIN (CHEM3D2Format, theCHEM3D2Format)
| OB_STATIC_PLUGIN (ChemDrawBinaryFormat, theChemDrawBinaryFormat)
| OB_STATIC_PLUGIN (ChemDrawFormat, theChemDrawFormat)
| OB_STATIC_PLUGIN (ChemKinFormat, theChemKinFormat)
| OB_STATIC_PLUGIN (CHTFormat, theCHTFormat)
| OB_STATIC_PLUGIN (CIFFormat, theCIFFormat)
| OB_STATIC_PLUGIN (CopyFormat, theCopyFormat)
| OB_STATIC_PLUGIN (CRK2DFormat, theCRK2DFormat)
| OB_STATIC_PLUGIN (CRK3DFormat, theCRK3DFormat)
| OB_STATIC_PLUGIN (CSRFormat, theCSRFormat)
| OB_STATIC_PLUGIN (CSSRFormat, theCSSRFormat)
| OB_STATIC_PLUGIN (DlpolyConfigFormat, theDlpolyConfigFormat)
| OB_STATIC_PLUGIN (DlpolyHISTORYFormat, theDlpolyHISTORYFormat)
| OB_STATIC_PLUGIN (DMolFormat, theDMolFormat)
| OB_STATIC_PLUGIN (FASTAFormat, theFASTAFormat)
| OB_STATIC_PLUGIN (FastSearchFormat, theFastSearchFormat)
| OB_STATIC_PLUGIN (FCHKFormat, theFCHKFormat)
| OB_STATIC_PLUGIN (FEATFormat, theFEATFormat)
| OB_STATIC_PLUGIN (FenskeZmatFormat, theFenskeZmatFormat)
| OB_STATIC_PLUGIN (FHIaimsFormat, theFHIaimsFormat)
| OB_STATIC_PLUGIN (FingerprintFormat, theFingerprintFormat)
| OB_STATIC_PLUGIN (FreeFormFractionalFormat, theFreeFormFractionalFormat)
| OB_STATIC_PLUGIN (GAMESSOutputFormat, theGAMESSOutputFormat)
| OB_STATIC_PLUGIN (GAMESSInputFormat, theGAMESSInputFormat)
| OB_STATIC_PLUGIN (GAMESSUKInputFormat, theGAMESSUKInputFormat)
| OB_STATIC_PLUGIN (GAMESSUKOutputFormat, theGAMESSUKOutputFormat)
| OB_STATIC_PLUGIN (OBGaussianCubeFormat, theGaussianCubeFormat)
| OB_STATIC_PLUGIN (GaussianOutputFormat, theGaussianOutputFormat)
| OB_STATIC_PLUGIN (GaussianInputFormat, theGaussianInputFormat)
| OB_STATIC_PLUGIN (GaussianZMatrixInputFormat, theGaussianZMatrixInputFormat)
| OB_STATIC_PLUGIN (GenBankFormat, theGenBankFormat)
| OB_STATIC_PLUGIN (GhemicalFormat, theGhemicalFormat)
| OB_STATIC_PLUGIN (GROMOS96Format, theGROMOS96Format)
| OB_STATIC_PLUGIN (GULPFormat, theGULPFormat)
| OB_STATIC_PLUGIN (HINFormat, theHINFormat)
| OB_STATIC_PLUGIN (JaguarOutputFormat, theJaguarOutputFormat)
| OB_STATIC_PLUGIN (JaguarInputFormat, theJaguarInputFormat)
| OB_STATIC_PLUGIN (MCDLFormat, theMCDLFormat)
| OB_STATIC_PLUGIN (MOLFormat, theMOLFormat)
| OB_STATIC_PLUGIN (SDFormat, theSDFormat)
| OB_STATIC_PLUGIN (OBT41Format, t41Format__)
| OB_STATIC_PLUGIN (OBMoldenFormat, moldenFormat__)
| OB_STATIC_PLUGIN (mmCIFFormat, themmCIFFormat)
| OB_STATIC_PLUGIN (MacroModFormat, theMacroModFormat)
| OB_STATIC_PLUGIN (MNAFormat, theMNAFormat)
| OB_STATIC_PLUGIN (MOL2Format, theMOL2Format)
| OB_STATIC_PLUGIN (MolproOutputFormat, theMolproOutputFormat)
| OB_STATIC_PLUGIN (MolproInputFormat, theMolproInputFormat)
| OB_STATIC_PLUGIN (MolReportFormat, theMolReportFormat)
| OB_STATIC_PLUGIN (MOPACFormat, theMOPACFormat)
| OB_STATIC_PLUGIN (MOPACCARTFormat, theMOPACCARTFormat)
| OB_STATIC_PLUGIN (MOPACINTFormat, theMOPACINTFormat)
| OB_STATIC_PLUGIN (MPDFormat, theMPDFormat)
| OB_STATIC_PLUGIN (MPQCFormat, theMPQCFormat)
| OB_STATIC_PLUGIN (MPQCInputFormat, theMPQCInputFormat)
| OB_STATIC_PLUGIN (MSIFormat, theMSIFormat)
| OB_STATIC_PLUGIN (OBMSMSFormat, msmsFormat__)
| OB_STATIC_PLUGIN (NulFormat, theNulFormat)
| OB_STATIC_PLUGIN (NWChemOutputFormat, theNWChemOutputFormat)
| OB_STATIC_PLUGIN (NWChemInputFormat, theNWChemInputFormat)
| OB_STATIC_PLUGIN (OBOpenDXCubeFormat, theOpenDXCubeFormat)
| OB_STATIC_PLUGIN (OutputFormat, theOutputFormat)
| OB_STATIC_PLUGIN (PCModelFormat, thePCModelFormat)
| OB_STATIC_PLUGIN (PDBFormat, thePDBFormat)
| OB_STATIC_PLUGIN (PDBQTFormat, thePDBQTFormat)
| OB_STATIC_PLUGIN (PNGFormat, thePNGFormat)
| OB_STATIC_PLUGIN (PovrayFormat, thePovrayFormat)
| OB_STATIC_PLUGIN (PQRFormat, thePQRFormat)
| OB_STATIC_PLUGIN (PQSFormat, thePQSFormat)
| OB_STATIC_PLUGIN (PWscfFormat, thePWscfFormat)
| OB_STATIC_PLUGIN (QChemOutputFormat, theQChemOutputFormat)
| OB_STATIC_PLUGIN (QChemInputFormat, theQChemInputFormat)
| OB_STATIC_PLUGIN (ReportFormat, theReportFormat)
| OB_STATIC_PLUGIN (SmiReactFormat, theSmiReactFormat)
| OB_STATIC_PLUGIN (RXNFormat, theRXNFormat)
| OB_STATIC_PLUGIN (ShelXFormat, theShelXFormat)
| OB_STATIC_PLUGIN (SMIFormat, theSMIFormat)
| OB_STATIC_PLUGIN (CANSMIFormat, theCANSMIFormat)
| OB_STATIC_PLUGIN (FIXFormat, theFIXFormat)
| OB_STATIC_PLUGIN (SVGFormat, theSVGFormat)
| OB_STATIC_PLUGIN (TextFormat, theTextFormat)
| OB_STATIC_PLUGIN (ThermoFormat, theThermoFormat)
| OB_STATIC_PLUGIN (TinkerFormat, theTinkerFormat)
| OB_STATIC_PLUGIN (TitleFormat, theTitleFormat)
| OB_STATIC_PLUGIN (TurbomoleFormat, theTurbomoleFormat)
| OB_STATIC_PLUGIN (UniChemFormat, theUniChemFormat)
| OB_STATIC_PLUGIN (VASPFormat, theVASPFormat)
| OB_STATIC_PLUGIN (ViewMolFormat, theViewMolFormat)
| OB_STATIC_PLUGIN (XEDFormat, theXEDFormat)
| OB_STATIC_PLUGIN (XTCFormat, theXTCFormat)
| OB_STATIC_PLUGIN (XYZFormat, theXYZFormat)
| OB_STATIC_PLUGIN (YOBFormat, theYOBFormat)
| OB_STATIC_PLUGIN (ZINDOFormat, theZINDOFormat)
| OB_STATIC_PLUGIN (ChemDrawXMLFormat, theChemDrawXMLFormat)
| OB_STATIC_PLUGIN (CMLFormat, theCMLFormat)
| OB_STATIC_PLUGIN (CMLReactFormat, theCMLReactFormat)
| OB_STATIC_PLUGIN (PubChemFormat, thePubChemFormat)
| OB_STATIC_PLUGIN (XMLFormat, theXMLFormat)
| OB_STATIC_PLUGIN (InChIFormat, theInChIFormat)
| OB_STATIC_PLUGIN (CanSmiles, theCanSmiles)
| OB_STATIC_PLUGIN (CompoundFilter, dummyCmpFilter)
| OB_STATIC_PLUGIN (MWFilter, theMWFilter)
| OB_STATIC_PLUGIN (SmartsFilter, firstSmartsFilter)
| OB_STATIC_PLUGIN (SmartsFilter, secondSmartsFilter)
| OB_STATIC_PLUGIN (TitleFilter, theTitleFilter)
| OB_STATIC_PLUGIN (FormulaDescriptor, TheFormulaDescriptor)
| OB_STATIC_PLUGIN (InChIFilter, theInChIFilter)
| OB_STATIC_PLUGIN (SmartsDescriptor, theHBD)
| OB_STATIC_PLUGIN (SmartsDescriptor, theHBA1)
| OB_STATIC_PLUGIN (SmartsDescriptor, theHBA2)
| OB_STATIC_PLUGIN (SmartsDescriptor, thenF)
| OB_STATIC_PLUGIN (OBGroupContrib, thelogP)
| OB_STATIC_PLUGIN (OBGroupContrib, theTPSA)
| OB_STATIC_PLUGIN (OBGroupContrib, theMR)
| OB_STATIC_PLUGIN (fingerprint2, thefingerprint2)
| OB_STATIC_PLUGIN (OBForceFieldGaff, theForceFieldGaff)
| OB_STATIC_PLUGIN (OBForceFieldGhemical, theForceFieldGhemical)
| OB_STATIC_PLUGIN (OBForceFieldMMFF94, theForceFieldMMFF94)
| OB_STATIC_PLUGIN (OBForceFieldMMFF94, theForceFieldMMFF94s)
| OB_STATIC_PLUGIN (OBForceFieldUFF, theForceFieldUFF)
| OB_STATIC_PLUGIN (OpAddInIndex, theOpAddInIndex)
| OB_STATIC_PLUGIN (OpAddPolarH, theOpAddPolarH)
| OB_STATIC_PLUGIN (OpCanonical, theOpCanonical)
| OB_STATIC_PLUGIN (OpConformer, theOpConformer)
| OB_STATIC_PLUGIN (OpFillUC, theOpFillUC)
| OB_STATIC_PLUGIN (OpEnergy, theOpEnergy)
| OB_STATIC_PLUGIN (OpMinimize, theOpMinimize)
| OB_STATIC_PLUGIN (OpGen2D, theOpGen2D)
| OB_STATIC_PLUGIN (OpGen3D, theOpGen3D)
| OB_STATIC_PLUGIN (OpNewS, theOpNewS)
| OB_STATIC_PLUGIN (OpPartialCharge, theOpPartialCharge)
| OB_STATIC_PLUGIN (OpReadConformers, theOpReadConformers)
| OB_STATIC_PLUGIN (OpSort, theOpSort)
| OB_STATIC_PLUGIN (OpUnique, theOpUnique)
| OB_STATIC_PLUGIN (OpExtraOut, theOpExtraOut)
| OB_STATIC_PLUGIN (GasteigerCharges, theGasteigerCharges)
| OB_STATIC_PLUGIN (MMFF94Charges, theMMFF94Charges)
| OB_STATIC_PLUGIN (QEqCharges, theQEqCharges)
| OB_STATIC_PLUGIN (QTPIECharges, theQTPIECharges)
std::vector< std::string > | EnableStaticPlugins ()
## Variables
const char * | _id

## Detailed Description

/ /

### Plugins

Plugins are a way of extending OpenBabel without having to alter any of the existing code. They may be built as shared libraries (DLLs with an extension .obf or .so files in a specified location) and distributed separately, but plugin classes can also be in the main code. In both cases they are discovered at startup when a global instance of the plugin class is instantiated. It iss registered by its constructor and is added to a static record of all the plugins of its particular type that are currently loaded.

There are two levels of plugin. The top layer (at the time of writing) are: formats descriptors fingerprints forcefields charges ops loaders but additional types can be added without disturbing the main API. At runtime babel -L will list the top level of plugins. They typically are abstract classes with virtual functions that define an interface for that type. Classes derived from these are the second layer of plugins, and can be listed at runtime like, for instance: babel -L formats cml where formats is the top level of plugin and cml is the id of a derived class of this type.

The top level of plugins will usually have their interfaces declared in header files compiled with the main API. The second level of plugin will typically not be known to the API at compile time, usually will not have a header file and must be accessed indirectly, to allow for the possibility that they may not be loaded:

       OBOp* pOp = OBOp::FindType("gen3D");
       if(!pOp)
         ...report error
       pOp->Do(mol);

This retrieves the global instance of the plugin. This is usually adequate but making a new instance may be appropriate in some cases.

Instances of some plugin classes can be constructed at startup from information in a text file and used in the same way as those defined in code. See OBDefine. This is appropriate for some classes that differ only by the datafile or SMARTS strings they use.

## Define Documentation

#define MAKE_PLUGIN | ( |  | BaseClass ) |

Value:

    protected:\
    static PluginMapType& Map(){static PluginMapType m;return m;}\
    virtual PluginMapType& GetMap()const{return Map();}\
    public:\
    static BaseClass*& Default(){static BaseClass* d;return d;}\
      BaseClass(const char* ID, bool IsDefault=false)\
     {_id=ID;if(ID&&*ID){if(IsDefault || Map().empty()) Default() = this;\
     Map()[ID]=this;PluginMap()[TypeID()] =this;}}\
    static BaseClass* FindType(const char* ID)\
     {if(!ID || *ID==0 || *ID==' ') return Default();\
     return static_cast<BaseClass*>(BaseFindType(Map(),ID));}

#define OB_STATIC_PLUGIN | ( |  | className,
|  |  | instanceName
| ) |  |

Value:

    class className; \
      OBAPI EXTERN className instanceName;

## Typedef Documentation

typedef PluginMapType::const_iterator PluginIterator`[inherited]`

## Function Documentation

virtual ~OBPlugin | ( | ) | `[inline, virtual, inherited]`

Virtual destructor necessary for classes with virtual functions.

virtual const char* Description | ( | ) | `[inline, virtual, inherited]`

Required description of a sub-type.

Reimplemented in OBFormat, OBGroupContrib, and OpTransform.

Referenced by OBOp::OpOptions().

virtual const char* TypeID | ( | ) | `[inline, virtual, inherited]`

Redefined by each plugin type: "formats", "fingerprints", etc.

Reimplemented in OBChargeModel, OBDescriptor, OBForceField, OBFormat, and OBOp.

bool Display | ( | std::string & | txt,
|  | const char * | param,
|  | const char * | ID = `NULL`
| ) |  | `[virtual, inherited]`

Write information on a plugin class to the string txt. Return false if not written. The default implementation outputs: the ID, a tab character, and the first line of the Description. The param string can be used in derived types to provide different outputs.

Reimplemented in OBDescriptor, and OBFormat.

virtual OBPlugin* MakeInstance | ( | const std::vector< std::string > & | ) | `[inline, virtual, inherited]`

Make a new instance of the class. See OpTransform, OBGroupContrib, SmartsDescriptor classes for derived versions. Usually, the first parameter is the classname, the next three are parameters(ID, filename, description) for a constructor, and the rest data.

Reimplemented in OBGroupContrib, and OpTransform.

Referenced by OBConversion::LoadFormatFiles().

virtual void Init | ( | ) | `[inline, virtual, inherited]`

Initialize the plugin. The default version does nothing.

OBPlugin * GetPlugin | ( | const char * | Type,
|  | const char * | ID
| ) |  | `[static, inherited]`

Get a pointer to a plugin from its type and ID. Return NULL if not found. If Type is NULL, search all types. Not cast to Type*

Referenced by OBConversion::LoadFormatFiles().

const char* GetID | ( | ) | const`[inline, inherited]`

Return the ID of the sub-type instance.

bool ListAsVector | ( | const char * | PluginID,
|  | const char * | param,
|  | std::vector< std::string > & | vlist
| ) |  | `[static, inherited]`

Output a list of sub-type classes of the the type PluginID, or, if PluginID is "plugins" or empty, a list of the base types. If PluginID is not recognized or is NULL, the base types are output and the return is false.

Referenced by OBConversion::GetSupportedInputFormat(), and OBConversion::GetSupportedOutputFormat().

void List | ( | const char * | PluginID,
|  | const char * | param = `NULL`,
|  | std::ostream * | os = `&std::cout`
| ) |  | `[static, inherited]`

As ListAsVector but sent to an ostream with a default of cout if not specified.

string ListAsString | ( | const char * | PluginID,
|  | const char * | param = `NULL`
| ) |  | `[static, inherited]`

As ListAsVector but returns a string containing the list.

string FirstLine | ( | const char * | txt ) | `[static, inherited]`

Utility function to return only the first line of a string.

Referenced by OBOp::OpOptions().

static PluginIterator Begin | ( | const char * | PluginID ) | `[inline, static, inherited]`

Return an iterator at the start of the map of the plugin types PluginID or, if there is no such map, the end of the top level plugin map.

Referenced by OBConversion::GetNextFormat(), and OBOp::OpOptions().

static PluginIterator End | ( | const char * | PluginID ) | `[inline, static, inherited]`

Referenced by OBConversion::GetNextFormat(), and OBOp::OpOptions().

virtual PluginMapType& GetMap | ( | ) | const`[pure virtual, inherited]`

Returns the map of the subtypes.

Referenced by OBPlugin::ListAsVector().

static PluginMapType& PluginMap | ( | ) | `[inline, static, protected, inherited]`

Returns a reference to the map of the plugin types. Is a function rather than a static member variable to avoid initialization problems.

OBPlugin::PluginMapType & GetTypeMap | ( | const char * | PluginID ) | `[static, protected, inherited]`

Returns the map of a particular plugin type, e.g. GetMapType("fingerprints")

OBPlugin * BaseFindType | ( | PluginMapType & | Map,
|  | const char * | ID
| ) |  | `[static, protected, inherited]`

Returns the type with the specified ID, or NULL if not found. Needs to be cast to the appropriate class in the calling routine.

OpenBabel::OB_STATIC_PLUGIN | ( | ACRFormat | ,
|  | theACRFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | ADFOutputFormat | ,
|  | theADFOutputFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | ADFInputFormat | ,
|  | theADFInputFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | AlchemyFormat | ,
|  | theAlchemyFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | AmberPrepFormat | ,
|  | theAmberPrepFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OBAPIInterface | ,
|  | theOBAPIInterface |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | BallStickFormat | ,
|  | theBallStickFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | BGFFormat | ,
|  | theBGFFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | BoxFormat | ,
|  | theBoxFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | CacaoFormat | ,
|  | theCacaoFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | CacheFormat | ,
|  | theCacheFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | CARFormat | ,
|  | theCARFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | CCCFormat | ,
|  | theCCCFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | CHEM3D1Format | ,
|  | theCHEM3D1Format |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | CHEM3D2Format | ,
|  | theCHEM3D2Format |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | ChemDrawBinaryFormat | ,
|  | theChemDrawBinaryFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | ChemDrawFormat | ,
|  | theChemDrawFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | ChemKinFormat | ,
|  | theChemKinFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | CHTFormat | ,
|  | theCHTFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | CIFFormat | ,
|  | theCIFFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | CopyFormat | ,
|  | theCopyFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | CRK2DFormat | ,
|  | theCRK2DFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | CRK3DFormat | ,
|  | theCRK3DFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | CSRFormat | ,
|  | theCSRFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | CSSRFormat | ,
|  | theCSSRFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | DlpolyConfigFormat | ,
|  | theDlpolyConfigFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | DlpolyHISTORYFormat | ,
|  | theDlpolyHISTORYFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | DMolFormat | ,
|  | theDMolFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | FASTAFormat | ,
|  | theFASTAFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | FastSearchFormat | ,
|  | theFastSearchFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | FCHKFormat | ,
|  | theFCHKFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | FEATFormat | ,
|  | theFEATFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | FenskeZmatFormat | ,
|  | theFenskeZmatFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | FHIaimsFormat | ,
|  | theFHIaimsFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | FingerprintFormat | ,
|  | theFingerprintFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | FreeFormFractionalFormat | ,
|  | theFreeFormFractionalFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | GAMESSOutputFormat | ,
|  | theGAMESSOutputFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | GAMESSInputFormat | ,
|  | theGAMESSInputFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | GAMESSUKInputFormat | ,
|  | theGAMESSUKInputFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | GAMESSUKOutputFormat | ,
|  | theGAMESSUKOutputFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OBGaussianCubeFormat | ,
|  | theGaussianCubeFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | GaussianOutputFormat | ,
|  | theGaussianOutputFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | GaussianInputFormat | ,
|  | theGaussianInputFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | GaussianZMatrixInputFormat | ,
|  | theGaussianZMatrixInputFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | GenBankFormat | ,
|  | theGenBankFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | GhemicalFormat | ,
|  | theGhemicalFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | GROMOS96Format | ,
|  | theGROMOS96Format |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | GULPFormat | ,
|  | theGULPFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | HINFormat | ,
|  | theHINFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | JaguarOutputFormat | ,
|  | theJaguarOutputFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | JaguarInputFormat | ,
|  | theJaguarInputFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | MCDLFormat | ,
|  | theMCDLFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | MOLFormat | ,
|  | theMOLFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | SDFormat | ,
|  | theSDFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OBT41Format | ,
|  | t41Format__ |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OBMoldenFormat | ,
|  | moldenFormat__ |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | mmCIFFormat | ,
|  | themmCIFFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | MacroModFormat | ,
|  | theMacroModFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | MNAFormat | ,
|  | theMNAFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | MOL2Format | ,
|  | theMOL2Format |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | MolproOutputFormat | ,
|  | theMolproOutputFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | MolproInputFormat | ,
|  | theMolproInputFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | MolReportFormat | ,
|  | theMolReportFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | MOPACFormat | ,
|  | theMOPACFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | MOPACCARTFormat | ,
|  | theMOPACCARTFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | MOPACINTFormat | ,
|  | theMOPACINTFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | MPDFormat | ,
|  | theMPDFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | MPQCFormat | ,
|  | theMPQCFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | MPQCInputFormat | ,
|  | theMPQCInputFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | MSIFormat | ,
|  | theMSIFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OBMSMSFormat | ,
|  | msmsFormat__ |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | NulFormat | ,
|  | theNulFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | NWChemOutputFormat | ,
|  | theNWChemOutputFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | NWChemInputFormat | ,
|  | theNWChemInputFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OBOpenDXCubeFormat | ,
|  | theOpenDXCubeFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OutputFormat | ,
|  | theOutputFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | PCModelFormat | ,
|  | thePCModelFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | PDBFormat | ,
|  | thePDBFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | PDBQTFormat | ,
|  | thePDBQTFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | PNGFormat | ,
|  | thePNGFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | PovrayFormat | ,
|  | thePovrayFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | PQRFormat | ,
|  | thePQRFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | PQSFormat | ,
|  | thePQSFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | PWscfFormat | ,
|  | thePWscfFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | QChemOutputFormat | ,
|  | theQChemOutputFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | QChemInputFormat | ,
|  | theQChemInputFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | ReportFormat | ,
|  | theReportFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | SmiReactFormat | ,
|  | theSmiReactFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | RXNFormat | ,
|  | theRXNFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | ShelXFormat | ,
|  | theShelXFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | SMIFormat | ,
|  | theSMIFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | CANSMIFormat | ,
|  | theCANSMIFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | FIXFormat | ,
|  | theFIXFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | SVGFormat | ,
|  | theSVGFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | TextFormat | ,
|  | theTextFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | ThermoFormat | ,
|  | theThermoFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | TinkerFormat | ,
|  | theTinkerFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | TitleFormat | ,
|  | theTitleFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | TurbomoleFormat | ,
|  | theTurbomoleFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | UniChemFormat | ,
|  | theUniChemFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | VASPFormat | ,
|  | theVASPFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | ViewMolFormat | ,
|  | theViewMolFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | XEDFormat | ,
|  | theXEDFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | XTCFormat | ,
|  | theXTCFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | XYZFormat | ,
|  | theXYZFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | YOBFormat | ,
|  | theYOBFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | ZINDOFormat | ,
|  | theZINDOFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | ChemDrawXMLFormat | ,
|  | theChemDrawXMLFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | CMLFormat | ,
|  | theCMLFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | CMLReactFormat | ,
|  | theCMLReactFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | PubChemFormat | ,
|  | thePubChemFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | XMLFormat | ,
|  | theXMLFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | InChIFormat | ,
|  | theInChIFormat |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | CanSmiles | ,
|  | theCanSmiles |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | CompoundFilter | ,
|  | dummyCmpFilter |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | MWFilter | ,
|  | theMWFilter |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | SmartsFilter | ,
|  | firstSmartsFilter |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | SmartsFilter | ,
|  | secondSmartsFilter |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | TitleFilter | ,
|  | theTitleFilter |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | FormulaDescriptor | ,
|  | TheFormulaDescriptor |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | InChIFilter | ,
|  | theInChIFilter |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | SmartsDescriptor | ,
|  | theHBD |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | SmartsDescriptor | ,
|  | theHBA1 |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | SmartsDescriptor | ,
|  | theHBA2 |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | SmartsDescriptor | ,
|  | thenF |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OBGroupContrib | ,
|  | thelogP |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OBGroupContrib | ,
|  | theTPSA |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OBGroupContrib | ,
|  | theMR |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | fingerprint2 | ,
|  | thefingerprint2 |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OBForceFieldGaff | ,
|  | theForceFieldGaff |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OBForceFieldGhemical | ,
|  | theForceFieldGhemical |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OBForceFieldMMFF94 | ,
|  | theForceFieldMMFF94 |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OBForceFieldMMFF94 | ,
|  | theForceFieldMMFF94s |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OBForceFieldUFF | ,
|  | theForceFieldUFF |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OpAddInIndex | ,
|  | theOpAddInIndex |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OpAddPolarH | ,
|  | theOpAddPolarH |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OpCanonical | ,
|  | theOpCanonical |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OpConformer | ,
|  | theOpConformer |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OpFillUC | ,
|  | theOpFillUC |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OpEnergy | ,
|  | theOpEnergy |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OpMinimize | ,
|  | theOpMinimize |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OpGen2D | ,
|  | theOpGen2D |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OpGen3D | ,
|  | theOpGen3D |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OpNewS | ,
|  | theOpNewS |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OpPartialCharge | ,
|  | theOpPartialCharge |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OpReadConformers | ,
|  | theOpReadConformers |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OpSort | ,
|  | theOpSort |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OpUnique | ,
|  | theOpUnique |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | OpExtraOut | ,
|  | theOpExtraOut |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | GasteigerCharges | ,
|  | theGasteigerCharges |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | MMFF94Charges | ,
|  | theMMFF94Charges |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | QEqCharges | ,
|  | theQEqCharges |
| ) |  |

OpenBabel::OB_STATIC_PLUGIN | ( | QTPIECharges | ,
|  | theQTPIECharges |
| ) |  |

std::vector< std::string > EnableStaticPlugins | ( | ) |

## Variable Documentation

const char* _id`[protected, inherited]`

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines